*! version 4.0.1  06sep2012
program qreg, eclass byable(recall) prop(sw mi)
	if _by() {
		local BY `"by `_byvars'`_byrc0':"'
	}
	if replay() {
		if ("`BY'"!="") error 190
		if ("`e(cmd)'"!="qreg") error 301
		Replay `0'
		exit
	}
	local vv : di "version " string(_caller()) ":"

	`vv' `BY' Estimate `0'

	version 10: ereturn local cmdline `"qreg `0'"'
end

program Estimate, eclass byable(recall) sort prop(sw mi)
	local vc = _caller()
	local vv : di "version " string(`vc') ":"

	version 12.1, missing

	if `vc' <= 12 {
		syntax varlist(numeric) [fw aw] [if] [in] [,		///
				Quantile(real 0.5) WLSiter(integer 1)	///
				noLOg Level(cilevel) * ]
	}
	else {
		syntax varlist(numeric) [fw aw] [if] [in] [,		///
				Quantile(real 0.5) WLSiter(integer 1)	///
				vce(string) noLOg Level(cilevel) * ]
	}
	_get_diopts diopts options, `options'

	OptimizeParse opopts options, `options'
	if "`options'" != "" {
		local k : word count `options'
		local options : list retokenize options
		local options : subinstr local options " " ", "
		di as err "{p}" plural(`k',"option") " {bf:`options'} " ///
		 plural(`k',"is","are") " not allowed{p_end}"
		exit 198
	}
	tempname quant
	local quant = `quantile'
	if (`quant'>=1) local quant = `quant'/100

	if `quant' <= 0 | `quant' >= 1 {
		di as err "{bf:quantile(`quantile')} is out of range"
		exit 198
	}
	if `wlsiter' < 1 { 
		di as err "{p}{bf:wlsiter(`wlsiter')} must be a positive " ///
		 "integer{p_end}"
		exit 198 
	}
	if "`weight'" != "" {
		local wweight `weight'
		if ("`weight'"=="pweight") local wweight iweight

		local weights [`wweight'`exp']
	}
	VCEParse `vce'
	local bwidth `r(bwidth)'
	local method `r(method)'
	local kernel `r(kernel)'

	marksample touse
	qui count if `touse'
	local N = r(N)
	if (!`N') error 2000
	if (`N'<=2) error 2001

	gettoken dep indep : varlist

	_rmcoll `indep' `weights' if `touse', forcedrop
	local indep `r(varlist)' 
	local varlist `dep' `indep'

	tempvar r i p
	qui gen long `i' = _n

	/* initial estimates via weighted least squares 		*/
	_qregwls `varlist' `weights' if `touse', r(`r') iterate(`wlsiter') ///
		quant(`quant') `log'

	if ("`log'"!="") local qui quietly

	/* stable sort							*/
	sort `r' `i'
	drop `r'
	drop `i'

	`qui' _qreg `varlist' if `touse' `weights', quant(`quant') ///
			`opopts'
	if r(convcode) != 1 { 
		di as err "convergence not achieved." 
		local rc = 430
	}
	else local rc = 0

	tempname b f_r rq rsd msd

	mat `b' = e(b)
	local N = r(N)
	scalar `f_r' = r(f_r)
	scalar `rq' = r(q_v)
	scalar `rsd' = r(sum_rdev)
	scalar `msd' = r(sum_adev)
	if "`method'" == "residual" {
		local basis `"`r(basis)'"'
		if !strlen("`basis'") {
			di as err "{p}cannot compute "                    ///
			 "{bf:vce(,residual)} because the basis numlist " ///
			 "exceeds the maximum macro length; try options " ///
			 "{bf:vce(,fitted)} or {bf:vce(,kernel()){p_end}"
			exit 123
		}
	}
	if `vc' <= 12 {
		tempvar s2
		/* old standard errors					*/
		qui _predict double `r' if `touse', resid
		qui gen double `s2' = abs(`r')
		summ `s2', meanonly
		qui replace `r' = 0 if `s2'<10e-10*r(mean)
		qui drop `s2'
		qui replace `r' = `quant' if `r'>0 & `r'<.
		qui replace `r' = (`quant' - 1) if `r'<0
		qui replace `r' = `r' / `f_r'
		qui _predict double `p' if `touse'
		`vv' qui reg `p' `indep' if `touse' [`weight'`exp'], dep(`dep') 

		local df_m = e(df_m)
		local df_r = e(df_r)
		capture assert `touse'
		if _rc { 
			preserve
			qui keep if `touse'
		}
		qui gen byte `s2' = 1 if `touse'
		qui _huber `r' `s2' [`weight'`exp']
		ereturn repost, buildfvinfo
	}
	else {
		/* new standard errors					*/
		if "`method'" != "fitted" {
			qui predict double `r', residuals
			local ropt resid(`r')
		}
		_ms_eq_info
		local k = r(k1)
		_ms_omit_info e(b)
		local nparm = `k'-r(k_omit)
		local df_m = `nparm' - !el(r(omit),1,`k')

		GetVCE `dep' `indep' `weights',		///
			bwidth(`bwidth')		///
			method(`method')		///
			touse(`touse')			///
			tau(`quant')			///
			level(`level')			///
			basis(`basis')			///
			`ropt'				///
			kernel(`kernel')		///
			nparm(`nparm')			///
			iterate(`wlsiter' `iterate')	

		tempname V sparsity bwidth kband
		mat `V' = r(V)
		scalar `sparsity' = r(sparsity)
		scalar `bwidth' = r(bwidth)
		local bwmeth `r(bwmeth)'
		scalar `f_r' = 1/`sparsity'

		if ("`method'"=="kernel") scalar `kband' = r(kband)

		local names : colfullnames `b'
		mat rownames `V' = `names'
		mat colnames `V' = `names'

		ereturn post `b' `V', esample(`touse')

		_post_vce_rank
		local df_r = `N' - e(rank)

		ereturn local depvar `dep'
		ereturn scalar sparsity = `sparsity'
		ereturn scalar bwidth = `bwidth'
		ereturn local bwmethod "`bwmeth'"
		ereturn local denmethod "`method'"
	}
	if "`method'" == "kernel" {
		ereturn local kernel "`kernel'"
		ereturn scalar  kbwidth = `kband'
	}	
	ereturn scalar df_m = `df_m'
	ereturn scalar df_r = `df_r'
	ereturn scalar f_r = `f_r'
	ereturn scalar N = `N'
	ereturn scalar q_v = `rq'
	ereturn scalar q = `quant'
	ereturn scalar sum_rdev = `rsd'
	ereturn scalar sum_adev = `msd'
	ereturn scalar convcode = `rc'

	ereturn local marginsnotok stdp stddp residuals

	global S_E_mdf = `df_m'
	global S_E_tdf = `df_r'
	global S_E_rd = `f_r'
	global S_E_nobs = `N'
	global S_E_q = `quant'
	global S_E_rq = `rq'
	global S_E_rsd = `rsd'
	global S_E_msd = `msd'
	global S_E_vl "`varlist'"
	global S_E_frc = `rc'

	if "`weight'" != "" {
		ereturn local wexp = "`exp'"
		ereturn local wtype = "`weight'" 
	}
	ereturn local properties "b V"

	global S_E_cmd "qreg"
	ereturn local predict "qreg_p"
	ereturn local cmd "qreg"

	Replay, `diopts' level(`level')
end

program define Replay
	syntax [, * ]

	_get_diopts diopts options, `options'
	if "`options'" != "" {
		local k : word count `options'
		di as err "{p}" plural(`k',"option") " {bf:`options'} " ///
		 plural(`k',"is","are") " not allowed{p_end}"
		exit 198
	}
	di
	if (e(q)==0.5) { 
		di in gr "Median regression"  ///
		 _col(54) "Number of obs =" in ye %10.0g e(N) 
	}
	else { 
		di in gr e(q) " Quantile regression" ///
		 _col(54) "Number of obs =" in ye %10.0g e(N) 
	}
	di in gr "  Raw sum of deviations" in ye %9.0g e(sum_rdev) ///
	 in gr " (about " in ye e(q_v) in gr ")" 
	di in gr "  Min sum of deviations" in ye %9.0g e(sum_adev) _col(54) ///
	 in gr "Pseudo R2     =" in ye %10.4f 1 - (e(sum_adev)/e(sum_rdev)) _n

	_coef_table, `diopts'

	error e(convcode)
end

program define OptimizeParse, sclass
	syntax namelist(max=2) [, iterate(passthru) nolog trace *]

	gettoken c_opopts c_opts : namelist

	if "`iterate'" != "" {
		local 0, `iterate'
		cap syntax, iterate(integer)
		local rc = _rc
		if (!`rc') local rc = (`iterate'<0)
		if `rc' {
			di as err "{p}{bf:iterate({it:#})} must be a " ///
			 "nonnegative integer{p_end}"
			exit 198
		}
		local iterate iterate(`iterate')
	}
	c_local `c_opopts' `iterate' `log' `trace'
	c_local `c_opts' `"`options'"'

	sreturn local options `options'
end

program define VCEParse, rclass
	syntax [anything(name=vcetype id="vce type")] [, FITted RESidual ///
		residuals KERnel(string) * ]

	if "`vcetype'" != "" {
		/* only one option for now				*/
		if "`vcetype'" != "iid" {
			di as err "{p}option {bf:vce(`vcetype')} is not " ///
			 "allowed{p_end}"
			exit 198
		}
	}
	return local vcetype iid

	if "`residuals'" != "" {
		local residual residual
		local residuals
	}	
	local k = ("`fitted'"!="") + ("`residual'"!="") + ("`kernel'"!="")
	if `k' > 1 {
		di as err "{p}invalid {bf:vce()} specification; only one " ///
		 "of {bf:fitted}, {bf:residual}, or {bf:kernel()} is "     ///
		 "allowed{p_end}"
		exit 198
	}
	if !`k' {
		/* check for kernel without option			*/
		local 0, `options'
		syntax, [ Kernel * ]
		local method `kernel'
		local kernel
	}
	if "`kernel'"!="" | "`method'"!="" {
		KernelParse, `kernel'
		/* r(kernel)						*/
		return add
		local method kernel
	}
	else local method `fitted'`residual'

	if ("`method'"=="") local method fitted

	return local method `method'

	BWidthParse, `options'
	/* r(bwidth)							*/
	return add
end

program define BWidthParse, rclass
	capture syntax [, BOfinger HSheather CHamberlain ]
	if _rc {
		local 0: subinstr local 0 "," ""
		local 0: list retokenize 0
		di as err "{p}invalid {bf:vce()} specification; suboption " ///
		 "{bf:`0'} is not allowed{p_end}"
		exit 198
	}

	local cnt : word count `bofinger' `hsheather' `chamberlain'
	if `cnt' > 1 {
		di as err "{p}invalid {bf:vce()} specification; only " ///
		 "one of {bf:bofinger}, {bf:hsheather}, or "              ///
		 "{bf:chamberlain} is allowed{p_end}"
		exit 198
	}
	if (`cnt'==0) local bwidth hsheather
	else local bwidth `bofinger'`hsheather'`chamberlain'

	return local bwidth `bwidth'
end

program define KernelParse, rclass
	capture syntax [, EPanechnikov 		///
			  epan2 		///
			  BIweight 		///
			  COSine		///
		 	  GAUssian 		///
			  PARzen 		///
			  RECtangle 		///
			  TRIangle  ]
	if _rc {
		local 0: subinstr local 0 "," ""
		local 0: list retokenize 0
		di as err "{p}invalid {bf:vce()} specification; suboption " ///
		 "{bf:kernel(`0')} is not allowed{p_end}"
		exit 198
	}
	local kernel `epanechnikov' `epan2' `biweight' `cosine'	
	local kernel `kernel' `gaussian' `parzen' `rectangle' 
	local kernel `kernel' `triangle' 

	local k : word count `kernel'
	if `k' > 1 {
		di as err "{p}invalid {bf:vce(,kernel())} specification; "  ///
		 "only one of {bf:epanechnikov}, {bf:epan2}, "		    ///
		 "{bf:biweight}, {bf:cosine}, {bf:gaussian}, {bf:parzen}, " ///
		 "{bf:rectangle}, or {bf:triangle} is allowed{p_end}"
		exit 198
	}
	if (!`k') local kernel epanechnikov

	return local kernel `kernel'
end

program define GetVCE, rclass
	syntax 	varlist(numeric fv) [fw aw iw/],	///
			bwidth(string)			///
			method(string) 			///
			touse(varname)			///
			tau(string)			///
			level(string)			///
			[				///
			basis(numlist)			///
			resid(varname)			///
			kernel(string) 			///
			nparm(integer 0)		///
			iterate(numlist)		/// 
			]
	tempname alpha
	scalar `alpha' = 1 - `level'/100

	gettoken dep indep : varlist

	tempname J N

	if "`weight'" != "" {
		tempvar wvar
		qui gen double `wvar' = `exp' if `touse'

		local weights [`weight'=`wvar']
	}
	qui mat accum `J' = `indep' if `touse' `weights'
	scalar `N' = r(N)

	tempname s band m
	scalar `s' = .

	if "`method'" == "fitted" {
		VCE_fitted `varlist', n(`=`N'') tau(`tau') bwidth(`bwidth') ///
			alpha(`alpha') touse(`touse') weight(`weight')      ///
			wvar(`wvar') options(`options')

		scalar `band' = r(band)

		scalar `s' = r(s)
	}
	else if "`method'" == "residual" {
		tempname F_l F_u
		tempvar ruse i ares

		qui gen double `ares' = abs(`resid')
		qui gen byte `ruse' = `touse'
		if "`weight'" == "fweight" {
			foreach j of numlist `basis' {
				qui replace `wvar' = `wvar'-1 in `j'
				if (!`wvar'[`j']) qui replace `ruse' = 0 in `j'
			}
		}
		else {
			foreach j of numlist `basis' {
				qui replace `ruse' = 0 in `j'
			}
		}
		/* new count						*/
		summarize `ruse' `weights', meanonly
		scalar `N' = r(sum)
		if !`N' {
			di as err "{p}no observations remain after " 	  ///
			 "dropping residuals associated with the linear " ///
			 "programming basis{p_end}"
			exit 2000
		}

		mata: _qreg_bwidth(`=`N'',`tau',"`bwidth'",`=`alpha'')
		scalar `band' = r(bwidth)

		tempname tau_l tau_u cenl cenu
		/* do not restrict (tau_l,tau_u) in (0,1); doing so	*/
		/*  produces std.errs. that are too small		*/
		scalar `tau_l' = `tau' - `band'
		scalar `tau_u' = `tau' + `band'
		if `tau_l'<0 | `tau_u'>1 {
			di as err "{p}VCE cannot be computed possibly due " ///
			 "to a small sample size; try a different "         ///
			 "{help qreg##qreg_bwidth:bandwidth} or "           ///
			 "{helpb bsqreg}{p_end}"
			exit 498
		}
		scalar `cenl' = 100*`tau_l'
		scalar `cenu' = 100*`tau_u'

		qui gen long `i' = _n
		/* stable sort						*/
		sort `ares' `i'
		drop `ares'
		drop `i'

		qui _pctile `resid' if `ruse' `weights', ///
			percentiles(`=`cenl'' `=`cenu'')

		scalar `F_l' = r(r1)   
		scalar `F_u' = r(r2)   

		scalar `s' = (`F_u'-`F_l')/(2*`band')
		if `s' <  epsdouble() {
			di as err "{p}sparsity estimate of " %10.0g `s' ///
			 " is too small; computation of coefficient "   ///
			 "standard errors cannot be completed{p_end}"
			exit 498
		}
	}
	else { // "`method'" == "kernel"
		VCE_kernel, resid(`resid') touse(`touse') n(`=`N'')    ///
			tau(`tau') bwidth(`bwidth') alpha(`alpha')     ///
			kernel(`kernel') weight(`weight') wvar(`wvar') ///
			iterate(`iterate') `vce0' indep(`indep')

		tempname kband

		scalar `band' = r(band)	
		scalar `kband' = r(kband)

		scalar `s' = r(s)
	}
	tempname V
	mat `J' = invsym(`J')
	mat `V' = `tau'*(1-`tau')*(`s'^2)*`J'

	if ("`method'"=="kernel") return scalar kband = `kband'

	return scalar sparsity = `s'
	return matrix V = `V' 
	return scalar bwidth = `band'
	return local bwmeth "`bwidth'"
	return scalar N = `N'
end

program define KernelBWidth, rclass
	syntax, sd(name) irq(name) tau(real) h(name)

	tempname kband sr k tph tmh
	scalar `sr' = `irq'/1.34
	scalar `k' = cond(`sd'<`sr', `sd', `sr')

	scalar `tph' = `tau'+`h'
	scalar `tmh' =  `tau'-`h'

	if (`tmh'<=0 |`tph'>=1) return scalar kband = .
	else return scalar kband = `k'*(invnormal(`tph')-invnormal(`tmh'))
end

program define VCE_kernel, rclass
	syntax, resid(varname) 		///
		touse(varname)		///
		n(real)			///
		tau(real)		///
		bwidth(string)		///
		alpha(name)		///
		kernel(string)		///
		[			///
		indep(string)		///
		weight(string)		///
		wvar(varname)		///
		iterate(numlist)	///
		]

	tempname H sd irq band kband

	if ("`weight'"!="") local weights [`weight'=`wvar']

	qui sum `resid' if `touse' `weights', detail
	scalar `irq' = r(p75) - r(p25)	
	scalar `sd'  = r(sd)

	mata: _qreg_bwidth(`n',`tau',"`bwidth'",`=`alpha'')
	scalar `band' = r(bwidth)

	KernelBWidth, sd(`sd') irq(`irq') tau(`tau') h(`band') 

	scalar `kband' = r(kband)	
	if missing(`kband') {
		di as err "{p}VCE cannot be computed possibly due to a " ///
		 "small sample size; try a different "                   ///
		 "{help qreg##qreg_bwidth:bandwidth} or {helpb bsqreg}{p_end}"
		exit 498
	}
	mata: _qreg_kernel("`kernel'",`=`kband'',"`resid'","`touse'","`wvar'")
	return add

	return scalar band = `band'
	return scalar kband = `kband'
end

program define VCE_fitted, rclass
	syntax varlist(numeric fv), 	///
		n(real) 		///
		tau(real) 		///
		bwidth(string) 		///
		alpha(name)		///
		touse(varname)		///
		[			///
		weight(string)		///
		wvar(varname)		///
		options(string)		///
		]

	tempname F_l F_u H tau_l tau_u s band
	tempvar  xb_l xb_u fi 

	mata: _qreg_bwidth(`n',`tau',"`bwidth'",`=`alpha'')
	scalar `band' = r(bwidth)

	/* do not restrict (tau_l,tau_u) in (0,1); doing so produces	*/
	/*  std.errs. that are too small				*/
	scalar `tau_l' = `tau' - `band' 
	scalar `tau_u' = `tau' + `band'
	if `tau_l'<=0 | `tau_u'>=1 {
		di as err "{p}VCE cannot be computed possibly due to a " ///
		 "small sample size; try a different "                   ///
		 "{help qreg##qreg_bwidth:bandwidth} or {helpb bsqreg}{p_end}"
		exit 498
	}
	if ("`weight'"!="") local weights [`weight'=`wvar']

	qui _qreg `varlist' if `touse' `weights', quant(`=`tau_l'') `options'
	if r(convcode) != 1 { 
		di as err "{p}VCE cannot be computed possibly due to a " ///
		 "small sample size; try {helpb bsqreg}{p_end}"
		exit 498
	}
	qui predict double `xb_l' if `touse', xb

	qui _qreg `varlist' if `touse' `weights', quant(`=`tau_u'') `options'
	if r(convcode) != 1 { 
		di as err "{p}VCE cannot be computed possibly due to a " ///
		 "small sample size; try {helpb bsqreg}{p_end}"
		exit 498
	}
	qui predict double `xb_u' if `touse', xb

	sum `xb_l' if `touse' `weights', meanonly
	scalar `F_l' = r(mean)

	sum `xb_u' if `touse' `weights', meanonly
	scalar `F_u' = r(mean)

	scalar `s' = (`F_u'-`F_l')/(2*`band')

	return scalar s = `s'
	return scalar band = `band'
end

mata:

void _qreg_bwidth(real scalar n,	///
		real scalar tau, 	///
		string scalar method,	/// 
		|real scalar alpha)	/// hsheather & chamberlain
{
	real scalar 	z, invtau, h

	invtau = invnormal(tau)

	if (method=="hsheather") {
		z = invnormal(1-alpha/2)
		h = (n^(-1/3))*(z^(2/3))*	///
			(1.5*normalden(invtau)^2/(2*invtau^2+1))^(1/3) 
	}
	else if (method=="bofinger") {
		h = n^(-1/5)*((4.5*normalden(invtau)^4)/(2*invtau^2+1)^2)^(1/5)
	}
	else { // (method=="chamberlain") 
		z = invnormal(1-alpha/2)
		h = z*sqrt(n^(-1)*tau*(1-tau))
	}

	st_rclear()
	st_numscalar("r(bwidth)", h)
}

void _qreg_kernel(string scalar kernel, 	///
		real scalar band,		/// 
		string scalar x,		///
		string scalar touse,		///
		string scalar wvar,		///
		|string scalar kvar)
{
	real colvector	xvec, val, cnd, wvec, w

	xvec = st_data(.,x,touse)
	xvec = xvec/band

	if (kernel == "biweight") {
		val = (15/16)*((1 :- xvec:^2):^2)	
		cnd = abs(xvec) :< 1
		val = val:*cnd 
	}
	else if (kernel == "cosine") {
		val = 1 :+ cos(2*pi()*xvec)
		cnd = abs(xvec) :< 0.5
		val = val:*cnd
	}
	else if (kernel == "epanechnikov") {
		val = (3/4)*(1 :- 0.2*xvec:^2)/sqrt(5)
		cnd = abs(xvec) :< sqrt(5)
		val = val:*cnd
	}
	else if (kernel == "epan2") {
		val = (3/4)*(1 :- xvec:^2)
		cnd = abs(xvec) :<  1
		val = val:*cnd
	}
	else if (kernel == "gaussian") {
		val = normalden(xvec)
	}
	else if (kernel == "parzen") {
		val = 4/3 :- 8*xvec:^2 + 8*abs(xvec):^3
		cnd = abs(xvec) :<= 0.5
		val = val:*cnd
		cnd = (0.5 :< abs(xvec) :& abs(xvec) :<= 1)
		val = val + ((8/3)*(1 :- abs(xvec)):^3):*cnd
	}
	else if (kernel == "rectangle") {
		val = 0.5*(abs(xvec) :< 1)
	}
	else { // (kernel=="triangle") {
		val = (1 :-abs(xvec)) :* (abs(xvec) :< 1)
	}	

	st_rclear()
	if (kvar == "") {
		if (wvar=="") st_numscalar("r(s)", band/mean(val) )
		else {
			wvec = st_data(.,wvar,touse)
			st_numscalar("r(s)", band/mean(val,wvec) )
		}
	}
	else st_store(., kvar, touse, val)
}
end
exit

References

Koenker, R. (2005) Quantile Regression. Cambridge University Press.
